<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResGuestsTypeResGuestProfileRPH ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfResGuestsTypeResGuestProfileRPH extends AbstractStructArrayBase
{
    /**
     * The ProfileRPH
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgProfileRPH[]
     */
    public $ProfileRPH;
    /**
     * Constructor method for ArrayOfResGuestsTypeResGuestProfileRPH
     * @uses DgArrayOfResGuestsTypeResGuestProfileRPH::setProfileRPH()
     * @param \dgsoft\StructType\DgProfileRPH[] $profileRPH
     */
    public function __construct(array $profileRPH = array())
    {
        $this
            ->setProfileRPH($profileRPH);
    }
    /**
     * Get ProfileRPH value
     * @return \dgsoft\StructType\DgProfileRPH[]|null
     */
    public function getProfileRPH()
    {
        return $this->ProfileRPH;
    }
    /**
     * Set ProfileRPH value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgProfileRPH[] $profileRPH
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuestProfileRPH
     */
    public function setProfileRPH(array $profileRPH = array())
    {
        foreach ($profileRPH as $arrayOfResGuestsTypeResGuestProfileRPHProfileRPHItem) {
            // validation for constraint: itemType
            if (!$arrayOfResGuestsTypeResGuestProfileRPHProfileRPHItem instanceof \dgsoft\StructType\DgProfileRPH) {
                throw new \InvalidArgumentException(sprintf('The ProfileRPH property can only contain items of \dgsoft\StructType\DgProfileRPH, "%s" given', is_object($arrayOfResGuestsTypeResGuestProfileRPHProfileRPHItem) ? get_class($arrayOfResGuestsTypeResGuestProfileRPHProfileRPHItem) : gettype($arrayOfResGuestsTypeResGuestProfileRPHProfileRPHItem)), __LINE__);
            }
        }
        $this->ProfileRPH = $profileRPH;
        return $this;
    }
    /**
     * Add item to ProfileRPH value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgProfileRPH $item
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuestProfileRPH
     */
    public function addToProfileRPH(\dgsoft\StructType\DgProfileRPH $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgProfileRPH) {
            throw new \InvalidArgumentException(sprintf('The ProfileRPH property can only contain items of \dgsoft\StructType\DgProfileRPH, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileRPH[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgProfileRPH|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgProfileRPH|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgProfileRPH|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgProfileRPH|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgProfileRPH|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileRPH
     */
    public function getAttributeName()
    {
        return 'ProfileRPH';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfResGuestsTypeResGuestProfileRPH
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
